\documentclass[11pt]{report}

\usepackage{amsmath}
\usepackage{textcomp}
\usepackage{amsfonts} 
\usepackage{graphicx}
\usepackage{tabto}
\usepackage{mathtools}
\usepackage{hyperref}
\usepackage{listings}
\usepackage[top=0.8in, bottom=0.8in, left=0.8in, right=0.8in]{geometry}
% Add other packages here %

\begin{document}

\begin{titlepage}


% -------------------------------------------------------------------
% You need to edit the details here
% -------------------------------------------------------------------

\begin{center}
\includegraphics[width=7cm]{imgs/epfl_logo.png}\\[2cm]

\linespread{1.2} {\normalsize \bf Scalable Computing Systems Laboratory (SaCS):}\\ \huge {\bfseries Model sharing and communication techniques in decentralized systems
}\\[0.5cm]
\normalsize \textit{\bf School of Computer and Communication Sciences, EPFL Lausanne, Switzerland}\\[3.5cm]
\linespread{1}

{\Large{\textit{\textnumero 321682:} Nevena Drešević}}\\[0.5cm]
{\large \emph{Project Advisor:} Professor Anne-Marie Kermarrec\\
\emph{Project Supervisors:} Dr. Rafael Pires, Mr. Rishi Sharma}\\[6cm]
\large Optional Semester Project\\[0.3cm] 
\today
\end{center}

\end{titlepage}


\begin{abstract}

Decentralized machine learning systems are essential in providing scalability while preserving the privacy and security of the data. They do so without needing a central coordinator and by leveraging distributed computing. These systems are applicable in healthcare, finance, social media platforms, and other areas, primarily focusing on industries holding sensitive data. Therefore, their performance is of huge importance, and improvements need to be made. This report aims to present a decentralized system's behavior when put through different communication protocols, machine learning model parameter sharing techniques, and its two model modification methods. We examine the performance of implementing communication in which nodes exchange information with all neighbors (D-PSGD) versus randomized communication (RWM). Additionally, we analyze those algorithms with various approaches for picking model parameters to share, as well as how to update the local model. The system is tested on three different datasets: a recommendation one (MovieLens Latest) and two image classification ones (CelebA, FEMNIST). The obtained results mostly show the domination of the D-PSGD algorithm, even with limited processing time, but with a significant trade-off regarding network load. Hence, the report results also provide a place for further improvements and research.

\end{abstract}

\tableofcontents

\input{introduction}

\input{background}

\input{implementation}

\input{evaluation}

\input{conclusion}

\addcontentsline{toc}{chapter}{Bibliography}

\begin{thebibliography}{9}

\bibitem{cnn}
Towards Data Science. S. Saha. Dec 15, 2018. \textit{A Comprehensive Guide to Convolutional Neural Networks — the ELI5 way.}
\\\texttt{https://towardsdatascience.com/a-comprehensive-guide-to-convolutional-neural-networks
\\-the-eli5-way-3bd2b1164a53}

\bibitem{movielens-latest}
Grouplens. 2021. MovieLens Latest Datasets.
\\\texttt{https://grouplens.org/datasets/movielens/latest/}

\bibitem{leaf}
arXiv:1812.01097. December 9, 2019. \textit{LEAF: A Benchmark for Federated Settings.}
\\\texttt{https://arxiv.org/abs/1812.01097}
\end{thebibliography}

\end{document}
